// aus: Guido Krüger, Thomas Stark: Handbuch der Java-Programmierung,
//      5. Auflage 2007 (HTML-Version)

import java.awt.*;
import java.awt.event.*;

public class MouseEvents2 extends Frame {
   private static final int LAECHELN = 1 ;
   private static final int GRIMMIG = 2 ;

   public MouseEvents2() {
      super("Mausklicks");
      addMouseListener(new MyMouseListener());

      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            setVisible(false);
            dispose();
            System.exit(0);
         }
      } );
}

   class MyMouseListener extends MouseAdapter {
      int cnt = 0;
      Graphics g ;
      int x ;
      int y ;

      public void mousePressed(MouseEvent event) {

         g = getGraphics();
         x = event.getX();
         y = event.getY();
         ++cnt ;

         if (event.getClickCount() == 1) {
            gesicht(x, y) ;
            zaehler(x, y, cnt);
         }

         if (event.isMetaDown()) {
            mund(x, y, GRIMMIG);
         } else {
            mund(x, y, LAECHELN);
         }
         
         if (event.getClickCount() == 2) {
            brille(x, y); ;
         }
      }

      // Hilfsmethoden
      private void gesicht(int x, int y) {
         g.drawOval(x-10, y-10, 20, 20);
         g.fillRect(x-6, y-5, 4, 5);
         g.fillRect(x+3, y-5, 4, 5);
      }

      private void mund(int x, int y, int status) {
         if (status == LAECHELN)  g.drawArc(x-7, y-7,14, 14, 225, 100);
         if (status == GRIMMIG)   g.drawLine(x-5, y+7, x+5, y+7) ;
      }

      private void brille(int x, int y) {
         g.drawLine(x-9,y-3,x+9,y-3);
      }

      private void zaehler(int x, int y, int cnt) {
         g.drawString("" + cnt, x + 10, y - 10);
      }
   }

   public static void main(String[] args) {
      MouseEvents2 wnd = new MouseEvents2();
      wnd.setSize(300,200);
      wnd.setLocation(200,100);
      wnd.setVisible(true);
   }
}