// aus: Guido Krüger, Thomas Stark: Handbuch der Java-Programmierung,
//      5. Auflage 2007 (HTML-Version)

import java.awt.*;
import java.awt.event.*;

public class MouseEvents3 extends Frame {
   private static final int LAECHELN = 1 ;
   private static final int GRIMMIG = 2 ;

   private int cnt = 0;
//   private Graphics g ;
   private int x ;
   private int y ;
   private int status = 0 ;
   private boolean doppelKlick  = false ;

   public MouseEvents3() {
      super("Mausklicks");
      addMouseListener(new MyMouseListener());

      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            setVisible(false);
            dispose();
            System.exit(0);
         }
      } );
   }

   public void paint(Graphics g) {
      gesicht(g, x, y) ;
      zaehler(g, x, y, cnt);

      mund(g,x, y, status);
      
      if (doppelKlick) {
         brille(g, x, y);
      }

   }

   class MyMouseListener extends MouseAdapter {

      public void mousePressed(MouseEvent event) {

         doppelKlick = false ;
//         g = getGraphics();
         x = event.getX();
         y = event.getY();
         ++cnt ;
         
         if (event.isMetaDown()) {
            status = GRIMMIG;
         } else {
            status = LAECHELN ;
         }

         if (event.getClickCount() == 2) {
           doppelKlick = true ;
         }

         repaint();
      }
   }

   // Hilfsmethoden
   private void gesicht(Graphics g, int x, int y) {
      g.drawOval(x-10, y-10, 20, 20);
      g.fillRect(x-6, y-5, 4, 5);
      g.fillRect(x+3, y-5, 4, 5);
   }

   private void mund(Graphics g, int x, int y, int status) {
      if (status == LAECHELN)  g.drawArc(x-7, y-7,14, 14, 225, 100);
      if (status == GRIMMIG)   g.drawLine(x-5, y+7, x+5, y+7) ;
   }

   private void brille(Graphics g, int x, int y) {
      g.drawLine(x-9,y-3,x+9,y-3);
   }

   private void zaehler(Graphics g, int x, int y, int cnt) {
      g.drawString("" + cnt, x + 10, y - 10);
   }

   public static void main(String[] args) {
      MouseEvents3 wnd = new MouseEvents3();
      wnd.setSize(300,200);
      wnd.setLocation(200,100);
      wnd.setVisible(true);
   }
}