// aus: Guido Krüger, Thomas Stark: Handbuch der Java-Programmierung,
//      5. Auflage 2007 (HTML-Version)

import java.awt.*;
import java.awt.event.*;

public class MouseMotionEvents2 extends Frame {
   private Rectangle actrect;

   public MouseMotionEvents2() {
      super("Mausklicks");
      addMouseListener(new MyMouseListener());
      addMouseMotionListener(new MyMouseMotionListener());

      addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               setVisible(false);
               dispose();
               System.exit(0);
            }
         });
   }

   public void paint(Graphics g) {
      if (actrect != null) {
         if ((actrect.x > 0) || (actrect.y > 0)) {
            g.drawRect(actrect.x, actrect.y, actrect.width, actrect.height);
         }
      }
   }

   class MyMouseListener extends MouseAdapter {
      public void mousePressed(MouseEvent event) {
         actrect = new Rectangle(event.getX(), event.getY(), 0, 0);
         System.out.println("Maustaste gedrückt");
      }

      public void mouseReleased(MouseEvent event) {
         System.out.println("Maustaste los gelassen");
      }
   }

   class MyMouseMotionListener extends MouseMotionAdapter {
      public void mouseDragged(MouseEvent event) {
         int x = event.getX();
         int y = event.getY();

         if ((x > actrect.x) && (y > actrect.y)) {
            actrect.width = x - actrect.x;
            actrect.height = y - actrect.y;
         }

         repaint();
      }
   }

   public static void main(String[] args) {
      MouseMotionEvents2 wnd = new MouseMotionEvents2();
      wnd.setSize(300, 200);
      wnd.setLocation(200, 100);
      wnd.setVisible(true);
   }
}
